/* $Id: main.c 4 2023-02-19 04:11:41Z nishi $ */

#include <ncron/util.h>
#include <ncron.h>

#include <stdio.h>
#include <stdlib.h>

char** argv;
int argc;

void ncron_version(){
	printf("ncron %s\n", NCRON_VERSION);
	exit(0);
}

int main(int argc_, char** argv_){
	argc = argc_;
	argv = argv_;
	int i;
	for(i = 1; argv[i] != NULL; i++){
		if(argv[i][0] == '-'){
			enum {
				SUCCESS = 0,
				CHARFAIL,
				LONGFAIL
			} ERR;
			char unknown_option = SUCCESS;
			char unknown_char;
			char* unknown_long;
			if(argv[i][1] != '-'){
				int j;
				for(j = 1; argv[i][j] != 0; j++){
					char opt = argv[i][j];
					if(opt == 'v'){
						ncron_version();
					}else{
						unknown_option = CHARFAIL;
						unknown_char = opt;
						break;
					}
				}
			}else{
				if(strcmp(argv[i], "--version") == 0){
					ncron_version();
				}else{
					unknown_option = LONGFAIL;
					unknown_long = argv[i];
				}
			}
			if(unknown_option != SUCCESS){
				fprintf(stderr, sstrcat3("%s: unknown option `", unknown_option == CHARFAIL ? "-%c" : "%s", "`\n"), argv[0], unknown_option == CHARFAIL ? unknown_char : unknown_long);
				return 1;
			}
		}
	}
	ncron_start();
}
