/* $Id: util.c 3 2023-02-19 03:40:03Z nishi $ */

#include <ncron/util.h>

#include <stdlib.h>
#include <stddef.h>

size_t sstrlen(const char* str){
	size_t result;
	for(result = 0; str[result] != 0; result++);
	return result;
}

char* sstrcpy(char* dest, const char* src){
	size_t i;
	for(i = 0; src[i] != 0; dest[i] = src[i], i++);
	dest[i] = 0;
}

char* sstrcat(const char* str1, const char* str2){
	char* result = malloc(sstrlen(str1) + sstrlen(str2) + 1);
	result[sstrlen(str1) + sstrlen(str2)] = 0;
	sstrcpy(result, str1);
	sstrcpy(result + sstrlen(str1), str2);
	return result;
}

char* sstrcat3(const char* str1, const char* str2, const char* str3){
	char* tmp = sstrcat(str1, str2);
	char* result = sstrcat(tmp, str3);
	free(tmp);
	return result;
}

char* sstrdup(const char* str){
	char* result = malloc(sstrlen(str) + 1);
	result[sstrlen(str)] = 0;
	sstrcpy(result, str);
	return result;
}

void** mqueue_ = NULL;
size_t mqueue_len = 0;

void* mqueue(void* ptr){
	if(mqueue_ == NULL){
		mqueue_ = malloc(0);
	}
	mqueue_ = realloc(mqueue_, sizeof(*mqueue_) * (mqueue_len + 1));
	mqueue_[mqueue_len] = ptr;
	mqueue_len++;
	return ptr;
}

void mqueue_free(){
	size_t i;
	for(i = 0; i < mqueue_len; i++) free(mqueue_[i]);
	free(mqueue_);
	mqueue_ = malloc(0);
}
